org.optaplanner.core.impl.score.buildin.bendablelong

## Class BendableLongScoreDefinition

- java.lang.Object
- - org.optaplanner.core.impl.score.definition.AbstractScoreDefinition<S>
  - - org.optaplanner.core.impl.score.definition.AbstractFeasibilityScoreDefinition<S>
    - - org.optaplanner.core.impl.score.definition.AbstractBendableScoreDefinition<BendableLongScore>
      - - org.optaplanner.core.impl.score.buildin.bendablelong.BendableLongScoreDefinition

- All Implemented Interfaces:
    Serializable, FeasibilityScoreDefinition<BendableLongScore>, ScoreDefinition<BendableLongScore>

      public class BendableLongScoreDefinition
      extends AbstractBendableScoreDefinition<BendableLongScore>

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.definition.AbstractBendableScoreDefinition

      `hardLevelsSize, softLevelsSize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BendableLongScoreDefinition(int hardLevelsSize, int softLevelsSize)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `BendableLongScore` | `buildOptimisticBound(InitializingScoreTrend initializingScoreTrend, BendableLongScore score)` Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
    `BendableLongScore` | `buildPessimisticBound(InitializingScoreTrend initializingScoreTrend, BendableLongScore score)` Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
    `BendableLongScoreHolder` | `buildScoreHolder(boolean constraintMatchEnabled)` Used by `DroolsScoreDirector`.
    `BendableLongScoreInliner` | `buildScoreInliner(boolean constraintMatchEnabled)` Used by `BavetConstraintFactory`
    `BendableLongScore` | `createScore(long... scores)`
    `BendableLongScore` | `createScoreUninitialized(int initScore, long... scores)`
    `BendableLongScore` | `fromLevelNumbers(int initScore, Number[] levelNumbers)` The opposite of `Score.toLevelNumbers()`.
    `Class<BendableLongScore>` | `getScoreClass()` Returns the `Class` of the actual `Score` implementation.
    `BendableLongScore` | `getZeroScore()` The score that represents zero.
    `BendableLongScore` | `parseScore(String scoreString)` Parses the `String` and returns a `Score`.

    - ### Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractBendableScoreDefinition

      `generateLevelLabels, getFeasibleLevelsSize, getHardLevelsSize, getLevelsSize, getSoftLevelsSize`

    - ### Methods inherited from class org.optaplanner.core.impl.score.definition.AbstractScoreDefinition

      `formatScore, getInitLabel, getLevelLabels, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.definition.ScoreDefinition

      `formatScore, getInitLabel, getLevelLabels, isNegativeOrZero, isPositiveOrZero`

- - ### Constructor Detail

    - #### BendableLongScoreDefinition

          public BendableLongScoreDefinition(int hardLevelsSize,
                                             int softLevelsSize)

  - ### Method Detail

    - #### getScoreClass

          public Class<BendableLongScore> getScoreClass()

      Description copied from interface: `ScoreDefinition`
      Returns the `Class` of the actual `Score` implementation. For example: returns `HardSoftScore.class` on `HardSoftScoreDefinition`.
      Returns:
        never null

    - #### getZeroScore

          public BendableLongScore getZeroScore()

      Description copied from interface: `ScoreDefinition`
      The score that represents zero.
      Returns:
        never null

    - #### parseScore

          public BendableLongScore parseScore(String scoreString)

      Description copied from interface: `ScoreDefinition`
      Parses the `String` and returns a `Score`.
      Parameters:
        `scoreString` - never null
      Returns:
        never null
      See Also:
        `ScoreDefinition.formatScore(Score)`, `ScoreUtils.parseScore(Class, String)`

    - #### fromLevelNumbers

          public BendableLongScore fromLevelNumbers(int initScore,
                                                    Number[] levelNumbers)

      Description copied from interface: `ScoreDefinition`
      The opposite of `Score.toLevelNumbers()`.
      Parameters:
        `initScore` - `<= 0`, managed by OptaPlanner, needed as a parameter in the `Score`'s creation method, see `Score.getInitScore()`
        `levelNumbers` - never null
      Returns:
        never null

    - #### createScore

          public BendableLongScore createScore(long... scores)

    - #### createScoreUninitialized

          public BendableLongScore createScoreUninitialized(int initScore,
                                                            long... scores)

    - #### buildScoreInliner

          public BendableLongScoreInliner buildScoreInliner(boolean constraintMatchEnabled)

      Description copied from interface: `ScoreDefinition`
      Used by `BavetConstraintFactory`
      Parameters:
        `constraintMatchEnabled` - true if `ScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildScoreHolder

          public BendableLongScoreHolder buildScoreHolder(boolean constraintMatchEnabled)

      Description copied from interface: `ScoreDefinition`
      Used by `DroolsScoreDirector`.
      Parameters:
        `constraintMatchEnabled` - true if `ScoreDirector.isConstraintMatchEnabled()` should be true
      Returns:
        never null

    - #### buildOptimisticBound

          public BendableLongScore buildOptimisticBound(InitializingScoreTrend initializingScoreTrend,
                                                        BendableLongScore score)

      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or better than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`.
      Returns:
        never null

    - #### buildPessimisticBound

          public BendableLongScore buildPessimisticBound(InitializingScoreTrend initializingScoreTrend,
                                                         BendableLongScore score)

      Description copied from interface: `ScoreDefinition`
      Builds a `Score` which is equal or worse than any other `Score` with more variables initialized (while the already variables don't change).
      Parameters:
        `initializingScoreTrend` - never null, with `InitializingScoreTrend.getLevelsSize()` equal to `ScoreDefinition.getLevelsSize()`.
        `score` - never null, with `Score.getInitScore()` `0`
      Returns:
        never null

Copyright © 2006–2020 JBoss by Red Hat. All rights reserved.